Index: src/backend/catalog/indexing.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/catalog/indexing.c,v
retrieving revision 1.93
diff -c -r1.93 indexing.c
*** src/backend/catalog/indexing.c	2002/05/24 18:57:55	1.93
--- src/backend/catalog/indexing.c	2002/06/15 16:37:58
***************
*** 45,52 ****
--- 45,56 ----
  {AttrDefaultIndex};
  char	   *Name_pg_class_indices[Num_pg_class_indices] =
  {ClassNameNspIndex, ClassOidIndex};
+ char	   *Name_pg_constraint_indices[Num_pg_constraint_indices] =
+ {ConstraintOidIndex, ConstraintRelidNameIndex};
  char	   *Name_pg_database_indices[Num_pg_database_indices] =
  {DatabaseNameIndex, DatabaseOidIndex};
+ char	   *Name_pg_depend_indices[Num_pg_depend_indices] =
+ {DependDependerIndex, DependDependeeIndex};
  char	   *Name_pg_group_indices[Num_pg_group_indices] =
  {GroupNameIndex, GroupSysidIndex};
  char	   *Name_pg_index_indices[Num_pg_index_indices] =
***************
*** 65,72 ****
  {OperatorOidIndex, OperatorNameNspIndex};
  char	   *Name_pg_proc_indices[Num_pg_proc_indices] =
  {ProcedureOidIndex, ProcedureNameNspIndex};
- char	   *Name_pg_relcheck_indices[Num_pg_relcheck_indices] =
- {RelCheckIndex};
  char	   *Name_pg_rewrite_indices[Num_pg_rewrite_indices] =
  {RewriteOidIndex, RewriteRelRulenameIndex};
  char	   *Name_pg_shadow_indices[Num_pg_shadow_indices] =
--- 69,74 ----
Index: src/backend/catalog/namespace.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/catalog/namespace.c,v
retrieving revision 1.22
diff -c -r1.22 namespace.c
*** src/backend/catalog/namespace.c	2002/05/20 23:51:41	1.22
--- src/backend/catalog/namespace.c	2002/06/15 16:37:59
***************
*** 25,30 ****
--- 25,31 ----
  #include "catalog/catname.h"
  #include "catalog/heap.h"
  #include "catalog/namespace.h"
+ #include "catalog/pg_depend.h"
  #include "catalog/pg_inherits.h"
  #include "catalog/pg_namespace.h"
  #include "catalog/pg_opclass.h"
***************
*** 1554,1560 ****
  	{
  		Oid			reloid = (Oid) lfirsti(lptr);
  
! 		heap_drop_with_catalog(reloid, true);
  		/*
  		 * Advance cmd counter to make catalog changes visible, in case
  		 * a later entry depends on this one.
--- 1555,1565 ----
  	{
  		Oid			reloid = (Oid) lfirsti(lptr);
  
! 		/*
! 		 * Cascade through all objects which depend on this one,
! 		 * temporary or otherwise.
! 		 */
! 		heap_drop_with_catalog(reloid, true, DEPEND_CASCADE);
  		/*
  		 * Advance cmd counter to make catalog changes visible, in case
  		 * a later entry depends on this one.
Index: src/backend/catalog/pg_aggregate.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/catalog/pg_aggregate.c,v
retrieving revision 1.48
diff -c -r1.48 pg_aggregate.c
*** src/backend/catalog/pg_aggregate.c	2002/05/22 17:20:58	1.48
--- src/backend/catalog/pg_aggregate.c	2002/06/15 16:37:59
***************
*** 19,24 ****
--- 19,26 ----
  #include "catalog/indexing.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_aggregate.h"
+ #include "catalog/pg_depend.h"
+ #include "catalog/pg_namespace.h"
  #include "catalog/pg_language.h"
  #include "catalog/pg_proc.h"
  #include "optimizer/cost.h"
***************
*** 53,58 ****
--- 55,62 ----
  	Oid			procOid;
  	TupleDesc	tupDesc;
  	int			i;
+ 	ObjectAddress	myself,
+ 					dependee;
  
  	/* sanity checks */
  	if (!aggName)
***************
*** 186,190 ****
--- 190,224 ----
  		CatalogCloseIndices(Num_pg_aggregate_indices, idescs);
  	}
  
+ 	/* Define Dependencies */
+ 	myself.classId = GetSysCacheOid(RELNAMENSP,
+ 									CStringGetDatum(AggregateRelationName),
+ 									ObjectIdGetDatum(PG_CATALOG_NAMESPACE),
+ 									0, 0);
+ 	myself.objectId = tup->t_data->t_oid;
+ 	myself.objectSubId = 0;
+ 
+ 	/* Depends on transition function */
+ 	dependee.classId = RelOid_pg_proc;
+ 	dependee.objectId = DatumGetObjectId(values[Anum_pg_aggregate_aggtransfn - 1]);
+ 	dependee.objectSubId = 0;
+ 	dependCreate(&myself, &dependee, false);
+ 
+ 	/* Depends on final function */
+ 	if (values[Anum_pg_aggregate_aggfinalfn - 1] != InvalidOid)
+ 	{
+ 		dependee.classId = RelOid_pg_proc;
+ 		dependee.objectId = DatumGetObjectId(values[Anum_pg_aggregate_aggfinalfn - 1]);
+ 		dependee.objectSubId = 0;
+ 		dependCreate(&myself, &dependee, false);
+ 	}
+ 
+ 	/* Depends on final transition type */
+ 	dependee.classId = RelOid_pg_type;
+ 	dependee.objectId = DatumGetObjectId(values[Anum_pg_aggregate_aggtranstype - 1]);
+ 	dependee.objectSubId = 0;
+ 	dependCreate(&myself, &dependee, false);
+ 
+ 	/* Cleanup */
  	heap_close(aggdesc, RowExclusiveLock);
  }
Index: src/backend/catalog/pg_operator.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/catalog/pg_operator.c,v
retrieving revision 1.69
diff -c -r1.69 pg_operator.c
*** src/backend/catalog/pg_operator.c	2002/05/21 22:05:54	1.69
--- src/backend/catalog/pg_operator.c	2002/06/15 16:38:04
***************
*** 21,26 ****
--- 21,28 ----
  #include "catalog/catname.h"
  #include "catalog/indexing.h"
  #include "catalog/namespace.h"
+ #include "catalog/pg_depend.h"
+ #include "catalog/pg_namespace.h"
  #include "catalog/pg_operator.h"
  #include "catalog/pg_type.h"
  #include "miscadmin.h"
***************
*** 262,267 ****
--- 264,270 ----
  	 */
  	operatorObjectId = simple_heap_insert(pg_operator_desc, tup);
  
+ 	/* Keep indexes up to date */
  	if (RelationGetForm(pg_operator_desc)->relhasindex)
  	{
  		Relation	idescs[Num_pg_operator_indices];
***************
*** 403,408 ****
--- 406,414 ----
  	TupleDesc	tupDesc;
  	int			i;
  
+ 	ObjectAddress	myself,
+ 					dependee;
+ 
  	/*
  	 * Sanity checks
  	 */
***************
*** 657,662 ****
--- 663,774 ----
  		CatalogOpenIndices(Num_pg_operator_indices, Name_pg_operator_indices, idescs);
  		CatalogIndexInsert(idescs, Num_pg_operator_indices, pg_operator_desc, tup);
  		CatalogCloseIndices(Num_pg_operator_indices, idescs);
+ 	}
+ 
+ 	/* Load our object address */
+ 	myself.classId = GetSysCacheOid(RELNAMENSP,
+ 									CStringGetDatum(OperatorRelationName),
+ 									ObjectIdGetDatum(PG_CATALOG_NAMESPACE),
+ 									0, 0);
+ 	myself.objectId = operatorObjectId;
+ 	myself.objectSubId = 0;
+ 
+ 	/* Procedure on its Namespace */
+ 	dependee.classId = GetSysCacheOid(RELNAMENSP,
+ 									  CStringGetDatum(NamespaceRelationName),
+ 									  ObjectIdGetDatum(PG_CATALOG_NAMESPACE),
+ 									  0, 0);
+ 
+ 	dependee.objectId = operatorNamespace;
+ 	dependee.objectSubId = 0;
+ 	dependCreate(&myself, &dependee, true);
+ 
+ 	/* Dependency on left type */
+ 	if (DatumGetObjectId(values[Anum_pg_operator_oprleft - 1]) != InvalidOid) {
+ 		dependee.classId = RelOid_pg_type;
+ 		dependee.objectId = DatumGetObjectId(values[Anum_pg_operator_oprleft - 1]);
+ 		dependee.objectSubId = 0;
+ 		dependCreate(&myself, &dependee, false);
+ 	}
+ 
+ 	/* Dependency on right type */
+ 	if (DatumGetObjectId(values[Anum_pg_operator_oprright - 1]) != InvalidOid) {
+ 		dependee.classId = RelOid_pg_type;
+ 		dependee.objectId = DatumGetObjectId(values[Anum_pg_operator_oprright - 1]);
+ 		dependee.objectSubId = 0;
+ 		dependCreate(&myself, &dependee, false);
+ 	}
+ 
+ 	/* Dependency on result type */
+ 	dependee.classId = RelOid_pg_type;
+ 	dependee.objectId = DatumGetObjectId(values[Anum_pg_operator_oprresult - 1]);
+ 	dependee.objectSubId = 0;
+ 	dependCreate(&myself, &dependee, false);
+ 
+ 	/* Dependency on commutator */
+ 	if (DatumGetObjectId(values[Anum_pg_operator_oprcom - 1]) != InvalidOid) {
+ 		dependee.classId = GetSysCacheOid(RELNAMENSP,
+ 										  CStringGetDatum(OperatorRelationName),
+ 										  ObjectIdGetDatum(PG_CATALOG_NAMESPACE),
+ 										  0, 0);
+ 		dependee.objectId = DatumGetObjectId(values[Anum_pg_operator_oprcom - 1]);
+ 		dependee.objectSubId = 0;
+ 		dependCreate(&myself, &dependee, false);
+ 	}
+ 
+ 	/* Dependency on negator */
+ 	if (DatumGetObjectId(values[Anum_pg_operator_oprnegate - 1]) != InvalidOid) {
+ 		dependee.classId = GetSysCacheOid(RELNAMENSP,
+ 										  CStringGetDatum(OperatorRelationName),
+ 										  ObjectIdGetDatum(PG_CATALOG_NAMESPACE),
+ 										  0, 0);
+ 		dependee.objectId = DatumGetObjectId(values[Anum_pg_operator_oprnegate - 1]);
+ 		dependee.objectSubId = 0;
+ 		dependCreate(&myself, &dependee, false);
+ 	}
+ 
+ 	/* Dependency on sort left hand operator */
+ 	if (DatumGetObjectId(values[Anum_pg_operator_oprjoin - 1]) != InvalidOid) {
+ 		dependee.classId = GetSysCacheOid(RELNAMENSP,
+ 										  CStringGetDatum(OperatorRelationName),
+ 										  ObjectIdGetDatum(PG_CATALOG_NAMESPACE),
+ 										  0, 0);
+ 		dependee.objectId = DatumGetObjectId(values[Anum_pg_operator_oprlsortop - 1]);
+ 		dependee.objectSubId = 0;
+ 		dependCreate(&myself, &dependee, false);
+ 	}
+ 
+ 	/* Dependency on sort right hand operator */
+ 	if (DatumGetObjectId(values[Anum_pg_operator_oprrsortop - 1]) != InvalidOid) {
+ 		dependee.classId = GetSysCacheOid(RELNAMENSP,
+ 										  CStringGetDatum(OperatorRelationName),
+ 										  ObjectIdGetDatum(PG_CATALOG_NAMESPACE),
+ 										  0, 0);
+ 		dependee.objectId = DatumGetObjectId(values[Anum_pg_operator_oprrsortop - 1]);
+ 		dependee.objectSubId = 0;
+ 		dependCreate(&myself, &dependee, false);
+ 	}
+ 
+ 	/* Dependency on implementation function */
+ 	dependee.classId = RelOid_pg_proc;
+ 	dependee.objectId = DatumGetObjectId(values[Anum_pg_operator_oprcode - 1]);
+ 	dependee.objectSubId = 0;
+ 	dependCreate(&myself, &dependee, false);
+ 
+ 	/* Dependency on restriction selectivity function */
+ 	if (DatumGetObjectId(values[Anum_pg_operator_oprjoin - 1]) != InvalidOid) {
+ 		dependee.classId = RelOid_pg_proc;
+ 		dependee.objectId = DatumGetObjectId(values[Anum_pg_operator_oprrest - 1]);
+ 		dependee.objectSubId = 0;
+ 		dependCreate(&myself, &dependee, false);
+ 	}
+ 
+ 	/* Dependency on join selectifity function */
+ 	if (DatumGetObjectId(values[Anum_pg_operator_oprjoin - 1]) != InvalidOid) {
+ 		dependee.classId = RelOid_pg_proc;
+ 		dependee.objectId = DatumGetObjectId(values[Anum_pg_operator_oprjoin - 1]);
+ 		dependee.objectSubId = 0;
+ 		dependCreate(&myself, &dependee, false);
  	}
  
  	heap_close(pg_operator_desc, RowExclusiveLock);
Index: src/backend/catalog/pg_proc.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/catalog/pg_proc.c,v
retrieving revision 1.75
diff -c -r1.75 pg_proc.c
*** src/backend/catalog/pg_proc.c	2002/05/22 18:33:15	1.75
--- src/backend/catalog/pg_proc.c	2002/06/15 16:38:05
***************
*** 17,23 ****
--- 17,25 ----
  #include "access/heapam.h"
  #include "catalog/catname.h"
  #include "catalog/indexing.h"
+ #include "catalog/pg_depend.h"
  #include "catalog/pg_language.h"
+ #include "catalog/pg_namespace.h"
  #include "catalog/pg_proc.h"
  #include "executor/executor.h"
  #include "fmgr.h"
***************
*** 77,82 ****
--- 79,87 ----
  	TupleDesc	tupDesc;
  	Oid			retval;
  
+ 	ObjectAddress	myself,
+ 					dependee;
+ 
  	/*
  	 * sanity checks
  	 */
***************
*** 250,255 ****
--- 255,309 ----
  	}
  
  	retval = tup->t_data->t_oid;
+ 
+ 	/* Record Dependencies */
+ 	myself.classId = RelOid_pg_proc;
+ 	myself.objectId = retval;
+ 	myself.objectSubId = 0;
+ 
+ 	/* Procedure on Language */
+ 	dependee.classId = GetSysCacheOid(RELNAMENSP,
+ 									  CStringGetDatum(LanguageRelationName),
+ 									  ObjectIdGetDatum(PG_CATALOG_NAMESPACE),
+ 									  0, 0);
+ 	dependee.objectId = languageObjectId;
+ 	dependee.objectSubId = 0;
+ 	dependCreate(&myself, &dependee, false);
+ 
+ 	/* Procedure on its Namespace */
+ 	dependee.classId = GetSysCacheOid(RELNAMENSP,
+ 									  CStringGetDatum(NamespaceRelationName),
+ 									  ObjectIdGetDatum(PG_CATALOG_NAMESPACE),
+ 									  0, 0);
+ 
+ 	dependee.objectId = procNamespace;
+ 	dependee.objectSubId = 0;
+ 	dependCreate(&myself, &dependee, true);
+ 
+ 	/*
+ 	 * Return Types are skipped in it's an InvalidOid (opaque) or if
+ 	 * the type is a shell type (prevent a type <-> function dependency)
+ 	 */
+ 	if (returnType != InvalidOid && get_typisdefined(returnType))
+ 	{
+ 		dependee.classId = RelOid_pg_type;
+ 		dependee.objectId = returnType;
+ 		dependee.objectSubId = 0;
+ 		dependCreate(&myself, &dependee, false);
+ 	}
+ 
+ 	for (i = 0; i < parameterCount; i++)
+ 	{
+ 		/* Parameter Types */
+ 		if (typev[i] != InvalidOid)
+ 		{
+ 			dependee.classId = RelOid_pg_type;
+ 			dependee.objectId = typev[i];
+ 			dependee.objectSubId = 0;
+ 			dependCreate(&myself, &dependee, false);
+ 		}
+ 	}
+ 
  	heap_freetuple(tup);
  
  	heap_close(rel, RowExclusiveLock);
Index: src/backend/catalog/pg_type.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/catalog/pg_type.c,v
retrieving revision 1.71
diff -c -r1.71 pg_type.c
*** src/backend/catalog/pg_type.c	2002/05/21 22:05:54	1.71
--- src/backend/catalog/pg_type.c	2002/06/15 16:38:05
***************
*** 17,22 ****
--- 17,24 ----
  #include "access/heapam.h"
  #include "catalog/catname.h"
  #include "catalog/indexing.h"
+ #include "catalog/pg_depend.h"
+ #include "catalog/pg_namespace.h"
  #include "catalog/pg_type.h"
  #include "miscadmin.h"
  #include "utils/builtins.h"
***************
*** 166,171 ****
--- 168,175 ----
  	NameData	name;
  	TupleDesc	tupDesc;
  	int			i;
+ 	ObjectAddress	myself,
+ 					dependee;
  
  	/*
  	 * validate size specifications: either positive (fixed-length) or -1
***************
*** 296,301 ****
--- 300,371 ----
  		CatalogOpenIndices(Num_pg_type_indices, Name_pg_type_indices, idescs);
  		CatalogIndexInsert(idescs, Num_pg_type_indices, pg_type_desc, tup);
  		CatalogCloseIndices(Num_pg_type_indices, idescs);
+ 	}
+ 
+ 	/*
+ 	 * Create dependencies
+ 	 */
+ 
+ 	/* Load our object address */
+ 	myself.classId = RelOid_pg_type;
+ 	myself.objectId = typeObjectId;
+ 	myself.objectSubId = 0;
+ 
+ 	/* Procedure on its Namespace */
+ 	dependee.classId = GetSysCacheOid(RELNAMENSP,
+ 									  CStringGetDatum(NamespaceRelationName),
+ 									  ObjectIdGetDatum(PG_CATALOG_NAMESPACE),
+ 									  0, 0);
+ 
+ 	dependee.objectId = typeNamespace;
+ 	dependee.objectSubId = 0;
+ 	dependCreate(&myself, &dependee, true);
+ 
+ 	/* Dependency on the input function */
+ 	dependee.classId = RelOid_pg_proc;
+ 	dependee.objectId = DatumGetObjectId(values[Anum_pg_type_typinput - 1]);
+ 	dependee.objectSubId = 0;
+ 	dependCreate(&myself, &dependee, false);
+ 
+ 	/* Dependency on the output function */
+ 	dependee.classId = RelOid_pg_proc;
+ 	dependee.objectId = DatumGetObjectId(values[Anum_pg_type_typoutput - 1]);
+ 	dependee.objectSubId = 0;
+ 	dependCreate(&myself, &dependee, false);
+ 
+ 	/* Dependency on the receive function */
+ 	dependee.classId = RelOid_pg_proc;
+ 	dependee.objectId = DatumGetObjectId(values[Anum_pg_type_typreceive - 1]);
+ 	dependee.objectSubId = 0;
+ 	dependCreate(&myself, &dependee, false);
+ 
+ 	/* Dependency on the send function */
+ 	dependee.classId = RelOid_pg_proc;
+ 	dependee.objectId = DatumGetObjectId(values[Anum_pg_type_typsend - 1]);
+ 	dependee.objectSubId = 0;
+ 	dependCreate(&myself, &dependee, false);
+ 
+ 	/*
+ 	 * Dependency on the relation for complex types.  Assume it's for
+ 	 * a relation of somekind and drop it when the relation is removed.
+ 	 */
+ 	if (DatumGetObjectId(values[Anum_pg_type_typrelid - 1]) != InvalidOid) {
+ 		dependee.classId = RelOid_pg_class;
+ 		dependee.objectId = DatumGetObjectId(values[Anum_pg_type_typrelid - 1]);
+ 		dependee.objectSubId = 0;
+ 		dependCreate(&myself, &dependee, true);
+ 	}
+ 
+ 	/*
+ 	 * Dependency on the element Id for arrays.  We can assume that it's for
+ 	 * an array and that we should always cascade into this type when the base
+ 	 * type is being removed.
+ 	 */
+ 	if (DatumGetObjectId(values[Anum_pg_type_typelem - 1]) != InvalidOid) {
+ 		dependee.classId = RelOid_pg_type;
+ 		dependee.objectId = DatumGetObjectId(values[Anum_pg_type_typelem - 1]);
+ 		dependee.objectSubId = 0;
+ 		dependCreate(&myself, &dependee, true);
  	}
  
  	/*
Index: src/backend/commands/aggregatecmds.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/aggregatecmds.c,v
retrieving revision 1.2
diff -c -r1.2 aggregatecmds.c
*** src/backend/commands/aggregatecmds.c	2002/04/27 03:45:00	1.2
--- src/backend/commands/aggregatecmds.c	2002/06/15 16:38:05
***************
*** 26,33 ****
  #include "catalog/catname.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_aggregate.h"
  #include "catalog/pg_proc.h"
- #include "commands/comment.h"
  #include "commands/defrem.h"
  #include "miscadmin.h"
  #include "parser/parse_func.h"
--- 26,33 ----
  #include "catalog/catname.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_aggregate.h"
+ #include "catalog/pg_depend.h"
  #include "catalog/pg_proc.h"
  #include "commands/defrem.h"
  #include "miscadmin.h"
  #include "parser/parse_func.h"
***************
*** 142,148 ****
  
  
  void
! RemoveAggregate(List *aggName, TypeName *aggType)
  {
  	Relation	relation;
  	HeapTuple	tup;
--- 142,148 ----
  
  
  void
! RemoveAggregate(List *aggName, TypeName *aggType, int behavior)
  {
  	Relation	relation;
  	HeapTuple	tup;
***************
*** 179,186 ****
  								 GetUserId()))
  		aclcheck_error(ACLCHECK_NOT_OWNER, NameListToString(aggName));
  
! 	/* Delete any comments associated with this function */
! 	DeleteComments(procOid, RelationGetRelid(relation));
  
  	/* Remove the pg_proc tuple */
  	simple_heap_delete(relation, &tup->t_self);
--- 179,186 ----
  								 GetUserId()))
  		aclcheck_error(ACLCHECK_NOT_OWNER, NameListToString(aggName));
  
! 	/* Deal with dependencies */
! 	dependDeleteTuple(tup, relation, behavior);
  
  	/* Remove the pg_proc tuple */
  	simple_heap_delete(relation, &tup->t_self);
Index: src/backend/commands/cluster.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/cluster.c,v
retrieving revision 1.81
diff -c -r1.81 cluster.c
*** src/backend/commands/cluster.c	2002/05/21 22:05:54	1.81
--- src/backend/commands/cluster.c	2002/06/15 16:38:05
***************
*** 26,31 ****
--- 26,32 ----
  #include "access/heapam.h"
  #include "catalog/heap.h"
  #include "catalog/index.h"
+ #include "catalog/pg_depend.h"
  #include "catalog/pg_index.h"
  #include "catalog/pg_proc.h"
  #include "commands/cluster.h"
***************
*** 118,125 ****
  
  	CommandCounterIncrement();
  
! 	/* Destroy old heap (along with its index) and rename new. */
! 	heap_drop_with_catalog(OIDOldHeap, allowSystemTableMods);
  
  	CommandCounterIncrement();
  
--- 119,129 ----
  
  	CommandCounterIncrement();
  
! 	/*
! 	 * Destroy old heap (along with its index) and rename new without
! 	 * blowing away objects which depend on this one.
! 	 */
! 	heap_drop_with_catalog(OIDOldHeap, allowSystemTableMods, DEPEND_IMPLICITONLY);
  
  	CommandCounterIncrement();
  
Index: src/backend/commands/comment.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/comment.c,v
retrieving revision 1.48
diff -c -r1.48 comment.c
*** src/backend/commands/comment.c	2002/05/21 22:05:54	1.48
--- src/backend/commands/comment.c	2002/06/15 16:38:08
***************
*** 19,24 ****
--- 19,25 ----
  #include "catalog/catname.h"
  #include "catalog/indexing.h"
  #include "catalog/namespace.h"
+ #include "catalog/pg_constraint.h"
  #include "catalog/pg_database.h"
  #include "catalog/pg_description.h"
  #include "catalog/pg_namespace.h"
***************
*** 57,62 ****
--- 58,64 ----
  static void CommentProc(List *function, List *arguments, char *comment);
  static void CommentOperator(List *opername, List *arguments, char *comment);
  static void CommentTrigger(List *qualname, char *comment);
+ static void CommentConstraint(List *qualname, char *comment);
  
  
  /*
***************
*** 100,105 ****
--- 102,110 ----
  		case TRIGGER:
  			CommentTrigger(stmt->objname, stmt->comment);
  			break;
+ 		case CONSTRAINT:
+ 			CommentConstraint(stmt->objname, stmt->comment);
+ 			break;
  		case SCHEMA:
  			CommentNamespace(stmt->objname, stmt->comment);
  			break;
***************
*** 232,258 ****
   * is destroyed.
   */
  void
! DeleteComments(Oid oid, Oid classoid)
  {
  	Relation	description;
! 	ScanKeyData skey[2];
  	SysScanDesc	sd;
  	HeapTuple	oldtuple;
  
  	/* Use the index to search for all matching old tuples */
  
! 	ScanKeyEntryInitialize(&skey[0],
  						   (bits16) 0x0,
  						   (AttrNumber) 1,
  						   (RegProcedure) F_OIDEQ,
  						   ObjectIdGetDatum(oid));
  
! 	ScanKeyEntryInitialize(&skey[1],
  						   (bits16) 0x0,
  						   (AttrNumber) 2,
  						   (RegProcedure) F_OIDEQ,
  						   ObjectIdGetDatum(classoid));
  
  	description = heap_openr(DescriptionRelationName, RowExclusiveLock);
  
  	sd = systable_beginscan(description, DescriptionObjIndex, true,
--- 237,275 ----
   * is destroyed.
   */
  void
! DeleteComments(Oid oid, Oid classoid, int32 subid)
  {
  	Relation	description;
! 	Relation	descriptionindex;
! 	ScanKeyData skey[3];
  	SysScanDesc	sd;
  	HeapTuple	oldtuple;
+ 	int			i = 0;
+ 
+ 	/* Open pg_description and its index */
  
+ 	description = heap_openr(DescriptionRelationName, RowExclusiveLock);
+ 	descriptionindex = index_openr(DescriptionObjIndex);
+ 
  	/* Use the index to search for all matching old tuples */
  
! 	ScanKeyEntryInitialize(&skey[i++],
  						   (bits16) 0x0,
  						   (AttrNumber) 1,
  						   (RegProcedure) F_OIDEQ,
  						   ObjectIdGetDatum(oid));
  
! 	ScanKeyEntryInitialize(&skey[i++],
  						   (bits16) 0x0,
  						   (AttrNumber) 2,
  						   (RegProcedure) F_OIDEQ,
  						   ObjectIdGetDatum(classoid));
  
+ 	ScanKeyEntryInitialize(&skey[i++],
+ 						   (bits16) 0x0,
+ 						   (AttrNumber) 3,
+ 						   (RegProcedure) F_INT4EQ,
+ 						   Int32GetDatum(subid));
  	description = heap_openr(DescriptionRelationName, RowExclusiveLock);
  
  	sd = systable_beginscan(description, DescriptionObjIndex, true,
***************
*** 805,809 ****
--- 822,904 ----
  	/* Done, but hold lock on relation */
  
  	heap_close(pg_trigger, AccessShareLock);
+ 	heap_close(relation, NoLock);
+ }
+ 
+ /*
+  * CommentConstraint --
+  *
+  * Enable commenting on constraints held within the pg_constraint
+  * table.  A qualified name is required as constraint names are
+  * unique per relation.
+  */
+ static void
+ CommentConstraint(List *qualName, char *comment)
+ {
+ 	int			nnames;
+ 	List	   *relName;
+ 	char	   *conName;
+ 	RangeVar   *rel;
+ 	Relation	pg_constraint,
+ 				relation;
+ 	HeapTuple	tuple;
+ 	SysScanDesc	scan;
+ 	ScanKeyData skey[2];
+ 	Oid			oid;
+ 	int			i = 0;
+ 
+ 	/* Separate relname and trig name */
+ 	nnames = length(qualName);
+ 	if (nnames < 2)
+ 		elog(ERROR, "CommentConstraint: must specify relation and constraint");
+ 	relName = ltruncate(nnames-1, listCopy(qualName));
+ 	conName = strVal(nth(nnames-1, qualName));
+ 
+ 	/* Open the owning relation to ensure it won't go away meanwhile */
+ 	rel = makeRangeVarFromNameList(relName);
+ 	relation = heap_openrv(rel, AccessShareLock);
+ 
+ 	/* Check object security */
+ 
+ 	if (!pg_class_ownercheck(RelationGetRelid(relation), GetUserId()))
+ 		aclcheck_error(ACLCHECK_NOT_OWNER, RelationGetRelationName(relation));
+ 
+ 	/*
+ 	 * Fetch the trigger tuple from pg_trigger.  There can be only one
+ 	 * because of the unique index.
+ 	 */
+ 	pg_constraint = heap_openr(ConstraintRelationName, AccessShareLock);
+ 
+ 	ScanKeyEntryInitialize(&skey[i++],
+ 						   0, Anum_pg_constraint_conrelid, F_OIDEQ,
+ 						   ObjectIdGetDatum(RelationGetRelid(relation)));
+ 
+ 	ScanKeyEntryInitialize(&skey[i++],
+ 						   0, Anum_pg_constraint_conname, F_NAMEEQ,
+ 						   CStringGetDatum(conName));
+ 
+ 	scan = systable_beginscan(pg_constraint, ConstraintRelidNameIndex, true,
+ 							  SnapshotNow,
+ 							  i, skey);
+ 
+ 	tuple = systable_getnext(scan);
+ 
+ 	/* If no trigger exists for the relation specified, notify user */
+ 
+ 	if (!HeapTupleIsValid(tuple))
+ 		elog(ERROR, "constraint \"%s\" for relation \"%s\" does not exist",
+ 			 conName, RelationGetRelationName(relation));
+ 
+ 	oid = tuple->t_data->t_oid;
+ 
+ 	systable_endscan(scan);
+ 
+ 	/* Create the comments with the pg_trigger oid */
+ 
+ 	CreateComments(oid, RelationGetRelid(pg_constraint), 0, comment);
+ 
+ 	/* Done, but hold lock on relation */
+ 
+ 	heap_close(pg_constraint, AccessShareLock);
  	heap_close(relation, NoLock);
  }
Index: src/backend/commands/dbcommands.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/dbcommands.c,v
retrieving revision 1.92
diff -c -r1.92 dbcommands.c
*** src/backend/commands/dbcommands.c	2002/05/25 16:30:59	1.92
--- src/backend/commands/dbcommands.c	2002/06/15 16:38:08
***************
*** 406,412 ****
  	heap_endscan(pgdbscan);
  
  	/* Delete any comments associated with the database */
! 	DeleteComments(db_id, RelationGetRelid(pgdbrel));
  
  	/*
  	 * Close pg_database, but keep exclusive lock till commit to ensure
--- 406,412 ----
  	heap_endscan(pgdbscan);
  
  	/* Delete any comments associated with the database */
! 	DeleteComments(db_id, RelationGetRelid(pgdbrel), 0);
  
  	/*
  	 * Close pg_database, but keep exclusive lock till commit to ensure
Index: src/backend/commands/functioncmds.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/functioncmds.c,v
retrieving revision 1.6
diff -c -r1.6 functioncmds.c
*** src/backend/commands/functioncmds.c	2002/05/22 17:20:58	1.6
--- src/backend/commands/functioncmds.c	2002/06/15 16:38:09
***************
*** 34,43 ****
  #include "access/heapam.h"
  #include "catalog/catname.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_language.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_type.h"
- #include "commands/comment.h"
  #include "commands/defrem.h"
  #include "miscadmin.h"
  #include "optimizer/cost.h"
--- 34,43 ----
  #include "access/heapam.h"
  #include "catalog/catname.h"
  #include "catalog/namespace.h"
+ #include "catalog/pg_depend.h"
  #include "catalog/pg_language.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_type.h"
  #include "commands/defrem.h"
  #include "miscadmin.h"
  #include "optimizer/cost.h"
***************
*** 531,536 ****
--- 531,537 ----
  
  /*
   * RemoveFunction
+  * RemoveFunctionById
   *		Deletes a function.
   *
   * Exceptions:
***************
*** 540,554 ****
   */
  void
  RemoveFunction(List *functionName,		/* function name to be removed */
! 			   List *argTypes)	/* list of TypeName nodes */
  {
  	Oid			funcOid;
- 	Relation	relation;
- 	HeapTuple	tup;
  
  	funcOid = LookupFuncNameTypeNames(functionName, argTypes, 
  									  true, "RemoveFunction");
  
  	relation = heap_openr(ProcedureRelationName, RowExclusiveLock);
  
  	tup = SearchSysCache(PROCOID,
--- 541,563 ----
   */
  void
  RemoveFunction(List *functionName,		/* function name to be removed */
! 			   List *argTypes,	/* list of TypeName nodes */
! 			   int behavior)
  {
  	Oid			funcOid;
  
  	funcOid = LookupFuncNameTypeNames(functionName, argTypes, 
  									  true, "RemoveFunction");
  
+ 	RemoveFunctionById(funcOid, behavior);
+ };
+ 
+ void
+ RemoveFunctionById(Oid funcOid, int behavior)
+ {
+ 	Relation	relation;
+ 	HeapTuple	tup;
+ 
  	relation = heap_openr(ProcedureRelationName, RowExclusiveLock);
  
  	tup = SearchSysCache(PROCOID,
***************
*** 556,587 ****
  						 0, 0, 0);
  	if (!HeapTupleIsValid(tup))	/* should not happen */
  		elog(ERROR, "RemoveFunction: couldn't find tuple for function %s",
! 			 NameListToString(functionName));
  
  	/* Permission check: must own func or its namespace */
  	if (!pg_proc_ownercheck(funcOid, GetUserId()) &&
  		!pg_namespace_ownercheck(((Form_pg_proc) GETSTRUCT(tup))->pronamespace,
  								 GetUserId()))
! 		aclcheck_error(ACLCHECK_NOT_OWNER, NameListToString(functionName));
  
  	if (((Form_pg_proc) GETSTRUCT(tup))->proisagg)
  		elog(ERROR, "RemoveFunction: function '%s' is an aggregate"
  			 "\n\tUse DROP AGGREGATE to remove it",
! 			 NameListToString(functionName));
! 
! 	if (((Form_pg_proc) GETSTRUCT(tup))->prolang == INTERNALlanguageId)
! 	{
! 		/* "Helpful" WARNING when removing a builtin function ... */
! 		elog(WARNING, "Removing built-in function \"%s\"",
! 			 NameListToString(functionName));
! 	}
  
! 	/* Delete any comments associated with this function */
! 	DeleteComments(funcOid, RelationGetRelid(relation));
  
  	simple_heap_delete(relation, &tup->t_self);
  
  	ReleaseSysCache(tup);
  
  	heap_close(relation, RowExclusiveLock);
  }
--- 565,593 ----
  						 0, 0, 0);
  	if (!HeapTupleIsValid(tup))	/* should not happen */
  		elog(ERROR, "RemoveFunction: couldn't find tuple for function %s",
! 			 get_func_name(funcOid));
  
  	/* Permission check: must own func or its namespace */
  	if (!pg_proc_ownercheck(funcOid, GetUserId()) &&
  		!pg_namespace_ownercheck(((Form_pg_proc) GETSTRUCT(tup))->pronamespace,
  								 GetUserId()))
! 		aclcheck_error(ACLCHECK_NOT_OWNER, get_func_name(funcOid));
  
  	if (((Form_pg_proc) GETSTRUCT(tup))->proisagg)
  		elog(ERROR, "RemoveFunction: function '%s' is an aggregate"
  			 "\n\tUse DROP AGGREGATE to remove it",
! 			 get_func_name(funcOid));
  
! 	/*
! 	 * Deal with dependencies
! 	 * Manages system function restrictions for us as well.
! 	 */
! 	dependDeleteTuple(tup, relation, behavior);
  
  	simple_heap_delete(relation, &tup->t_self);
  
  	ReleaseSysCache(tup);
  
  	heap_close(relation, RowExclusiveLock);
+ 
  }
Index: src/backend/commands/indexcmds.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/indexcmds.c,v
retrieving revision 1.74
diff -c -r1.74 indexcmds.c
*** src/backend/commands/indexcmds.c	2002/05/20 23:51:42	1.74
--- src/backend/commands/indexcmds.c	2002/06/15 16:38:11
***************
*** 567,573 ****
   *		...
   */
  void
! RemoveIndex(RangeVar *relation)
  {
  	Oid			indOid;
  	HeapTuple	tuple;
--- 567,573 ----
   *		...
   */
  void
! RemoveIndex(RangeVar *relation, int behavior)
  {
  	Oid			indOid;
  	HeapTuple	tuple;
***************
*** 585,591 ****
  
  	ReleaseSysCache(tuple);
  
! 	index_drop(indOid);
  }
  
  /*
--- 585,591 ----
  
  	ReleaseSysCache(tuple);
  
! 	index_drop(indOid, behavior);
  }
  
  /*
